use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
#[derive(Debug, Clone)]
pub struct VkAccelerationStructureBuildSizesInfoKHR {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub accelerationStructureSize: VkDeviceSize,
    pub updateScratchSize: VkDeviceSize,
    pub buildScratchSize: VkDeviceSize,
}

impl VkAccelerationStructureBuildSizesInfoKHR {
    pub fn new(
        acceleration_structure_size: VkDeviceSize,
        update_scratch_size: VkDeviceSize,
        build_scratch_size: VkDeviceSize,
    ) -> Self {
        VkAccelerationStructureBuildSizesInfoKHR {
            sType: VK_STRUCTURE_TYPE_ACCELERATION_STRUCTURE_BUILD_SIZES_INFO_KHR,
            pNext: ptr::null(),
            accelerationStructureSize: acceleration_structure_size,
            updateScratchSize: update_scratch_size,
            buildScratchSize: build_scratch_size,
        }
    }
}
